/**************************************************************************
 * HeXHub C++ SDK 0.3b Files Copyright (C) 2007-2008 Mikhail Polenin      *
 * HeXHub is Copyright(C) Albu Cristian Laurentiu                         *
 * This SDK's Purpose is to wrap around the HeXHub API to help plugin     *
 * developers organize their function calls and have more ease in coding  *
 * HeXHub Plugins.                                                        *
 * Files that should be included in this distribution:                    *
 *    HeXHubSDK.h - Header                                                *
 *    HeXHubSDK.cpp - Source File                                         *
 *    SDKReadme.txt - Documentation                                       *
 *    license.txt - License Information                                   *
 **************************************************************************/

#include "HeXHubSDK.h"

//HexHub

lpfnGetFunction						HexHub::GetFunction											= 0;

//Window
#if(HEX_VERSION >= 501)
lpfnGetHubWindow					HexHub::Window::GetHubWindow								= 0;
#endif

//Core

lpfnGetVersion						HexHub::Core::GetVersion									= 0;
lpfnGetUserCount					HexHub::Core::GetUserCount									= 0;
lpfnGetUserIds						HexHub::Core::GetUserIds									= 0;
lpfnGetMastersCount					HexHub::Core::GetMastersCount								= 0;
lpfnGetMastersIds					HexHub::Core::GetMastersIds									= 0;
lpfnGetIpCacheInfo					HexHub::Core::GetIpCacheInfo								= 0;
lpfnSetIpCacheInfo					HexHub::Core::SetIpCacheInfo								= 0;
lpfnRegisterCommand					HexHub::Core::RegisterCommand								= 0;
lpfnUnregisterCommand				HexHub::Core::UnregisterCommand								= 0;
lpfnRegisterHelpString				HexHub::Core::RegisterHelpString							= 0;
lpfnUnregisterHelpString			HexHub::Core::UnregisterHelpString							= 0;
lpfnRegisterUserCommand				HexHub::Core::RegisterUserCommand							= 0;
lpfnUnregisterUserCommand			HexHub::Core::UnregisterUserCommand							= 0;
lpfnRegisterChatFilter				HexHub::Core::RegisterChatFilter							= 0;
lpfnUnregisterChatFilter			HexHub::Core::UnregisterChatFilter							= 0;
lpfnRegisterBot						HexHub::Core::RegisterBot									= 0;
#if (HEX_VERSION >= 317)
lpfnRegisterBotEx					HexHub::Core::RegisterBotEx									= 0;
#endif
lpfnUnregisterBot					HexHub::Core::UnregisterBot									= 0;
lpfnCallHubCommand					HexHub::Core::CallHubCommand								= 0;
lpfnAcceptUser						HexHub::Core::AcceptUser									= 0;
lpfnDisconnectUser					HexHub::Core::DisconnectUser								= 0;
#if (HEX_VERSION >= 307)
lpfnGetTopic						HexHub::Core::GetTopic										= 0;
lpfnSetTopic						HexHub::Core::SetTopic										= 0;
lpfnGetMOTD							HexHub::Core::GetMOTD										= 0;
lpfnSetMOTD							HexHub::Core::SetMOTD										= 0;
#endif
#if (HEX_VERSION >= 320)
lpfnSetBan							HexHub::Core::SetBan										= 0;
#endif
#if (HEX_VERSION >= 311)
lpfnGetHubUptime					HexHub::Core::GetHubUptime									= 0;
#endif
#if (HEX_VERSION >= 315)
lpfnGetHublistEntry					HexHub::Core::GetHublistEntry								= 0;
#endif

//Accounts

lpfnCreateAccount					HexHub::Core::Accounts::CreateAccount						= 0;
lpfnDeleteAccount					HexHub::Core::Accounts::DeleteAccount						= 0;
lpfnMoveAccount						HexHub::Core::Accounts::MoveAccount							= 0;
lpfnSetProfile						HexHub::Core::Accounts::SetProfile							= 0;
lpfnGetProfile						HexHub::Core::Accounts::GetProfile							= 0;
lpfnGetNextProfile					HexHub::Core::Accounts::GetNextProfile						= 0;
lpfnSetAccount						HexHub::Core::Accounts::SetAccount							= 0;
lpfnGetAccount						HexHub::Core::Accounts::GetAccount							= 0;
lpfnGetNextAccount					HexHub::Core::Accounts::GetNextAccount						= 0;

//Users
lpfnNickFromId						HexHub::Users::NickFromId									= 0;
lpfnClientNickFromId				HexHub::Users::ClientNickFromId								= 0;
lpfnIdFromNick						HexHub::Users::IdFromNick									= 0;
lpfnGetInfo							HexHub::Users::GetInfo										= 0;
lpfnGetFullInfo						HexHub::Users::GetFullInfo									= 0;
lpfnSetInfo							HexHub::Users::SetInfo										= 0;
lpfnGetDescription					HexHub::Users::GetDescription								= 0;
lpfnSetDescription					HexHub::Users::SetDescription								= 0;
lpfnGetTag							HexHub::Users::GetTag										= 0;
lpfnSetTag							HexHub::Users::SetTag										= 0;
lpfnGetConnection					HexHub::Users::GetConnection								= 0;
lpfnSetConnection					HexHub::Users::SetConnection								= 0;
lpfnGetMail							HexHub::Users::GetMail										= 0;
lpfnSetMail							HexHub::Users::SetMail										= 0;
lpfnGetShareString					HexHub::Users::GetShareString								= 0;
lpfnSetShareString					HexHub::Users::SetShareString								= 0;
lpfnGetIP							HexHub::Users::GetIP										= 0;
lpfnGetIPString						HexHub::Users::GetIPString									= 0;
lpfnGetISPName						HexHub::Users::GetISPName									= 0;
lpfnGetOpStatus						HexHub::Users::GetOpStatus									= 0;
lpfnSetOpStatus						HexHub::Users::SetOpStatus									= 0;
lpfnGetLanguage						HexHub::Users::GetLanguage									= 0;
lpfnSetLanguage						HexHub::Users::SetLanguage									= 0;
lpfnGetMode							HexHub::Users::GetMode										= 0;
lpfnSetMode							HexHub::Users::SetMode										= 0;
lpfnModeTransform					HexHub::Users::ModeTransform								= 0;
lpfnAllocUserData					HexHub::Users::AllocUserData								= 0;
lpfnFreeUserData					HexHub::Users::FreeUserData									= 0;
lpfnGetUserData						HexHub::Users::GetUserData									= 0;
lpfnSetUserData						HexHub::Users::SetUserData									= 0;

//Registration of a certain user

lpfnGetRights						HexHub::Users::Registration::GetRights						= 0;
lpfnSetRights						HexHub::Users::Registration::SetRights						= 0;
lpfnGetAccessLevel					HexHub::Users::Registration::GetAccessLevel					= 0;
lpfnSetAccessLevel					HexHub::Users::Registration::SetAccessLevel					= 0;
lpfnGetProfileId					HexHub::Users::Registration::GetProfileId					= 0;
lpfnGetAccountId					HexHub::Users::Registration::GetAccountId					= 0;


//Traffic from user
lpfnDisableOutputToUser				HexHub::Users::Traffic::DisableOutputToUser					= 0;
lpfnProcessUserTraffic				HexHub::Users::Traffic::ProcessUserTraffic					= 0;

//Data
lpfnSendTo							HexHub::Data::SendTo										= 0;
lpfnSendToAll						HexHub::Data::SendToAll										= 0;
lpfnSendNotificationMessage			HexHub::Data::SendNotificationMessage						= 0;

#if (HEX_VERSION >= 500)
//HTTP
lpfnHTTPSendTo						HexHub::HTTP::HTTPSendTo									= 0;
lpfnHTTPSendHeaders					HexHub::HTTP::HTTPSendHeaders								= 0;
lpfnHTTPRedirect					HexHub::HTTP::HTTPRedirect									= 0;
#endif

#if (HEX_VERSION >= 400)
//Firewall
lpfnFirewallGetVersion				HexHub::Firewall::FirewallGetVersion						= 0;
lpfnFirewallGetAboutString			HexHub::Firewall::FirewallGetAboutString					= 0;
lpfnFirewallEnable					HexHub::Firewall::FirewallEnable							= 0;
lpfnFirewallDisable					HexHub::Firewall::FirewallDisable							= 0;
lpfnFirewallBanRange				HexHub::Firewall::FirewallBanRange							= 0;
lpfnFirewallUnbanRange				HexHub::Firewall::FirewallUnbanRange						= 0;
lpfnFirewallLookupRange				HexHub::Firewall::FirewallLookupRange						= 0;
lpfnFirewallGetSettings				HexHub::Firewall::FirewallGetSettings						= 0;
lpfnFirewallChangeSettings			HexHub::Firewall::FirewallChangeSettings					= 0;
lpfnFirewallRegisterHubPort			HexHub::Firewall::FirewallRegisterHubPort					= 0;
lpfnFirewallUnregisterHubPort		HexHub::Firewall::FirewallUnregisterHubPort					= 0;
lpfnFirewallGetStats				HexHub::Firewall::FirewallGetStats							= 0;
lpfnFirewallGetPortStats			HexHub::Firewall::FirewallGetPortStats						= 0;
lpfnDDoSFilterIP					HexHub::Firewall::DDoSFilterIP								= 0;
lpfnDDoSDeleteFilter				HexHub::Firewall::DDoSDeleteFilter							= 0;
lpfnDDoSCountFilteredIPs			HexHub::Firewall::DDoSCountFilteredIPs						= 0;
lpfnDDoSGetFilter					HexHub::Firewall::DDoSGetFilter								= 0;
#endif

#define GetF(FName) HexHub::GetFunction(FName)
#define TryPtr(ptr) if (ptr == 0) return false

bool HexHub::Initialize(lpfnGetFunction GetFunction)
{
	HexHub::GetFunction								= GetFunction;

	//Window
#if (HEX_VERSION >= 501)
	HexHub::Window::GetHubWindow					= reinterpret_cast<lpfnGetHubWindow>						(GetF("GetHubWindow"));
	TryPtr(HexHub::Window::GetHubWindow);
#endif

	//Core
	HexHub::Core::AcceptUser						= reinterpret_cast<lpfnAcceptUser>							(GetF("AcceptUser"));
	HexHub::Core::CallHubCommand					= reinterpret_cast<lpfnCallHubCommand>						(GetF("CallHubCommand"));
	HexHub::Core::DisconnectUser					= reinterpret_cast<lpfnDisconnectUser>						(GetF("DisconnectUser"));
#if (HEX_VERSION >= 315)
	HexHub::Core::GetHublistEntry					= reinterpret_cast<lpfnGetHublistEntry>						(GetF("GetHublistEntry"));
#endif
#if (HEX_VERSION >= 311)
	HexHub::Core::GetHubUptime						= reinterpret_cast<lpfnGetHubUptime>						(GetF("GetHubUptime"));
#endif
	HexHub::Core::GetIpCacheInfo					= reinterpret_cast<lpfnGetIpCacheInfo>						(GetF("GetIpCacheInfo"));
	HexHub::Core::GetMastersCount					= reinterpret_cast<lpfnGetMastersCount>						(GetF("GetMastersCount"));
	HexHub::Core::GetMastersIds						= reinterpret_cast<lpfnGetMastersIds>						(GetF("GetMastersIds"));
#if (HEX_VERSION >= 307)
	HexHub::Core::GetMOTD							= reinterpret_cast<lpfnGetMOTD>								(GetF("GetMOTD"));
	HexHub::Core::GetTopic							= reinterpret_cast<lpfnGetTopic>							(GetF("GetTopic"));
#endif
	HexHub::Core::GetUserCount						= reinterpret_cast<lpfnGetUserCount>						(GetF("GetUserCount"));
	HexHub::Core::GetUserIds						= reinterpret_cast<lpfnGetUserIds>							(GetF("GetUserIds"));
	HexHub::Core::GetVersion						= reinterpret_cast<lpfnGetVersion>							(GetF("GetVersion"));
	HexHub::Core::RegisterBot						= reinterpret_cast<lpfnRegisterBot>							(GetF("RegisterBot"));
#if (HEX_VERSION >= 317)
	HexHub::Core::RegisterBotEx						= reinterpret_cast<lpfnRegisterBotEx>						(GetF("RegisterBotEx"));
#endif
	HexHub::Core::RegisterChatFilter				= reinterpret_cast<lpfnRegisterChatFilter>					(GetF("RegisterChatFilter"));
	HexHub::Core::RegisterCommand					= reinterpret_cast<lpfnRegisterCommand>						(GetF("RegisterCommand"));
	HexHub::Core::RegisterHelpString				= reinterpret_cast<lpfnRegisterHelpString>					(GetF("RegisterHelpString"));
	HexHub::Core::RegisterUserCommand				= reinterpret_cast<lpfnRegisterUserCommand>					(GetF("RegisterUserCommand"));
#if (HEX_VERSION >= 320)
	HexHub::Core::SetBan							= reinterpret_cast<lpfnSetBan>								(GetF("SetBan"));
#endif
	HexHub::Core::SetIpCacheInfo					= reinterpret_cast<lpfnSetIpCacheInfo>						(GetF("SetIpCacheInfo"));
#if (HEX_VERSION >= 307)
	HexHub::Core::SetMOTD							= reinterpret_cast<lpfnSetMOTD>								(GetF("SetMOTD"));
	HexHub::Core::SetTopic							= reinterpret_cast<lpfnSetTopic>							(GetF("SetTopic"));
#endif
	HexHub::Core::UnregisterBot						= reinterpret_cast<lpfnUnregisterBot>						(GetF("UnregisterBot"));
	HexHub::Core::UnregisterChatFilter				= reinterpret_cast<lpfnUnregisterChatFilter>				(GetF("UnregisterChatFilter"));
	HexHub::Core::UnregisterCommand					= reinterpret_cast<lpfnUnregisterCommand>					(GetF("UnregisterCommand"));
	HexHub::Core::UnregisterHelpString				= reinterpret_cast<lpfnUnregisterHelpString>				(GetF("UnregisterHelpString"));
	HexHub::Core::UnregisterUserCommand				= reinterpret_cast<lpfnUnregisterUserCommand>				(GetF("UnregisterUserCommand"));
	TryPtr(HexHub::Core::AcceptUser);
	TryPtr(HexHub::Core::CallHubCommand);
	TryPtr(HexHub::Core::DisconnectUser);
#if (HEX_VERSION >= 315)
	TryPtr(HexHub::Core::GetHublistEntry);
#endif
#if (HEX_VERSION >= 311)
	TryPtr(HexHub::Core::GetHubUptime);
#endif
	TryPtr(HexHub::Core::GetIpCacheInfo);
	TryPtr(HexHub::Core::GetMastersCount);
	TryPtr(HexHub::Core::GetMastersIds);
#if (HEX_VERSION >= 307)
	TryPtr(HexHub::Core::GetMOTD);
	TryPtr(HexHub::Core::GetTopic);
#endif
	TryPtr(HexHub::Core::GetUserCount);
	TryPtr(HexHub::Core::GetUserIds);
	TryPtr(HexHub::Core::GetVersion);
	TryPtr(HexHub::Core::RegisterBot);
#if (HEX_VERSION >= 317)
	TryPtr(HexHub::Core::RegisterBotEx);
#endif
	TryPtr(HexHub::Core::RegisterChatFilter);
	TryPtr(HexHub::Core::RegisterCommand);
	TryPtr(HexHub::Core::RegisterHelpString);
	TryPtr(HexHub::Core::RegisterUserCommand);
#if (HEX_VERSION >= 320)
	TryPtr(HexHub::Core::SetBan);
#endif
	TryPtr(HexHub::Core::SetIpCacheInfo);
#if (HEX_VERSION >= 307)
	TryPtr(HexHub::Core::SetMOTD);
	TryPtr(HexHub::Core::SetTopic);
#endif
	TryPtr(HexHub::Core::UnregisterBot);
	TryPtr(HexHub::Core::UnregisterChatFilter);
	TryPtr(HexHub::Core::UnregisterCommand);
	TryPtr(HexHub::Core::UnregisterHelpString);
	TryPtr(HexHub::Core::UnregisterUserCommand);

	//Accounts
	HexHub::Core::Accounts::CreateAccount			= reinterpret_cast<lpfnCreateAccount>						(GetF("CreateAccount"));
	HexHub::Core::Accounts::DeleteAccount			= reinterpret_cast<lpfnDeleteAccount>						(GetF("DeleteAccount"));
	HexHub::Core::Accounts::GetAccount				= reinterpret_cast<lpfnGetAccount>							(GetF("GetAccount"));
	HexHub::Core::Accounts::GetNextAccount			= reinterpret_cast<lpfnGetNextAccount>						(GetF("GetNextAccount"));
	HexHub::Core::Accounts::GetNextProfile			= reinterpret_cast<lpfnGetNextProfile>						(GetF("GetNextProfile"));
	HexHub::Core::Accounts::GetProfile				= reinterpret_cast<lpfnGetProfile>							(GetF("GetProfile"));
	HexHub::Core::Accounts::MoveAccount				= reinterpret_cast<lpfnMoveAccount>							(GetF("MoveAccount"));
	HexHub::Core::Accounts::SetAccount				= reinterpret_cast<lpfnSetAccount>							(GetF("SetAccount"));
	HexHub::Core::Accounts::SetProfile				= reinterpret_cast<lpfnSetProfile>							(GetF("SetProfile"));
	TryPtr(HexHub::Core::Accounts::CreateAccount);
	TryPtr(HexHub::Core::Accounts::DeleteAccount);
	TryPtr(HexHub::Core::Accounts::GetAccount);
	TryPtr(HexHub::Core::Accounts::GetNextAccount);
	TryPtr(HexHub::Core::Accounts::GetNextProfile);
	TryPtr(HexHub::Core::Accounts::GetProfile);
	TryPtr(HexHub::Core::Accounts::MoveAccount);
	TryPtr(HexHub::Core::Accounts::SetAccount);
	TryPtr(HexHub::Core::Accounts::SetProfile);

	//Data
	HexHub::Data::SendNotificationMessage			= reinterpret_cast<lpfnSendNotificationMessage>				(GetF("SendNotificationMessage"));
	HexHub::Data::SendTo							= reinterpret_cast<lpfnSendTo>								(GetF("SendTo"));
	HexHub::Data::SendToAll							= reinterpret_cast<lpfnSendToAll>							(GetF("SendToAll"));
	TryPtr(HexHub::Data::SendNotificationMessage);
	TryPtr(HexHub::Data::SendTo);
	TryPtr(HexHub::Data::SendToAll);
	
#if (HEX_VERSION >= 400)
	//Firewall
	HexHub::Firewall::DDoSCountFilteredIPs			= reinterpret_cast<lpfnDDoSCountFilteredIPs>				(GetF("DDoSCountFilteredIPs"));
	HexHub::Firewall::DDoSDeleteFilter				= reinterpret_cast<lpfnDDoSDeleteFilter>					(GetF("DDoSDeleteFilter"));
	HexHub::Firewall::DDoSFilterIP					= reinterpret_cast<lpfnDDoSFilterIP>						(GetF("DDoSFilterIP"));
	HexHub::Firewall::DDoSGetFilter					= reinterpret_cast<lpfnDDoSGetFilter>						(GetF("DDoSGetFilter"));
	HexHub::Firewall::FirewallBanRange				= reinterpret_cast<lpfnFirewallBanRange>					(GetF("FirewallBanRange"));
	HexHub::Firewall::FirewallChangeSettings		= reinterpret_cast<lpfnFirewallChangeSettings>				(GetF("FirewallChangeSettings"));
	HexHub::Firewall::FirewallDisable				= reinterpret_cast<lpfnFirewallDisable>						(GetF("FirewallDisable"));
	HexHub::Firewall::FirewallEnable				= reinterpret_cast<lpfnFirewallEnable>						(GetF("FirewallEnable"));
	HexHub::Firewall::FirewallGetAboutString		= reinterpret_cast<lpfnFirewallGetAboutString>				(GetF("FirewallGetAboutString"));
	HexHub::Firewall::FirewallGetPortStats			= reinterpret_cast<lpfnFirewallGetPortStats>				(GetF("FirewallGetPortStats"));
	HexHub::Firewall::FirewallGetSettings			= reinterpret_cast<lpfnFirewallGetSettings>					(GetF("FirewallGetSettings"));
	HexHub::Firewall::FirewallGetStats				= reinterpret_cast<lpfnFirewallGetStats>					(GetF("FirewallGetStats"));
	HexHub::Firewall::FirewallGetVersion			= reinterpret_cast<lpfnFirewallGetVersion>					(GetF("FirewallGetVersion"));
	HexHub::Firewall::FirewallLookupRange			= reinterpret_cast<lpfnFirewallLookupRange>					(GetF("FirewallLookupRange"));
	HexHub::Firewall::FirewallRegisterHubPort		= reinterpret_cast<lpfnFirewallRegisterHubPort>				(GetF("FirewallRegisterHubPort"));
	HexHub::Firewall::FirewallUnbanRange			= reinterpret_cast<lpfnFirewallUnbanRange>					(GetF("FirewallUnbanRange"));
	HexHub::Firewall::FirewallUnregisterHubPort		= reinterpret_cast<lpfnFirewallUnregisterHubPort>			(GetF("FirewallUnregisterHubPort"));
	TryPtr(HexHub::Firewall::DDoSCountFilteredIPs);
	TryPtr(HexHub::Firewall::DDoSDeleteFilter);
	TryPtr(HexHub::Firewall::DDoSFilterIP);
	TryPtr(HexHub::Firewall::DDoSGetFilter);
	TryPtr(HexHub::Firewall::FirewallBanRange);
	TryPtr(HexHub::Firewall::FirewallChangeSettings);
	TryPtr(HexHub::Firewall::FirewallDisable);
	TryPtr(HexHub::Firewall::FirewallEnable);
	TryPtr(HexHub::Firewall::FirewallGetAboutString);
	TryPtr(HexHub::Firewall::FirewallGetPortStats);
	TryPtr(HexHub::Firewall::FirewallGetSettings);
	TryPtr(HexHub::Firewall::FirewallGetStats);
	TryPtr(HexHub::Firewall::FirewallGetVersion);
	TryPtr(HexHub::Firewall::FirewallLookupRange);
	TryPtr(HexHub::Firewall::FirewallRegisterHubPort);
	TryPtr(HexHub::Firewall::FirewallUnbanRange);
	TryPtr(HexHub::Firewall::FirewallUnregisterHubPort);
#endif

#if (HEX_VERSION >= 500)
	//HTTP
	HexHub::HTTP::HTTPRedirect						= reinterpret_cast<lpfnHTTPRedirect>						(GetF("HTTPRedirect"));
	//HexHub::HTTP::HTTPSendHeaders					= reinterpret_cast<lpfnHTTPSendHeaders>						(GetF("HTTPSendHeaders"));
	HexHub::HTTP::HTTPSendTo						= reinterpret_cast<lpfnHTTPSendTo>							(GetF("HTTPSendTo"));
	TryPtr(HexHub::HTTP::HTTPRedirect);
	//TryPtr(HexHub::HTTP::HTTPSendHeaders);
	TryPtr(HexHub::HTTP::HTTPSendTo);
#endif
	
	//Users
	HexHub::Users::AllocUserData					= reinterpret_cast<lpfnAllocUserData>						(GetF("AllocUserData"));
	HexHub::Users::ClientNickFromId					= reinterpret_cast<lpfnClientNickFromId>					(GetF("ClientNickFromId"));
	HexHub::Users::FreeUserData						= reinterpret_cast<lpfnFreeUserData>						(GetF("FreeUserData"));
	HexHub::Users::GetConnection					= reinterpret_cast<lpfnGetConnection>						(GetF("GetConnection"));
	HexHub::Users::GetDescription					= reinterpret_cast<lpfnGetDescription>						(GetF("GetDescription"));
	HexHub::Users::GetFullInfo						= reinterpret_cast<lpfnGetFullInfo>							(GetF("GetFullInfo"));
	HexHub::Users::GetInfo							= reinterpret_cast<lpfnGetInfo>								(GetF("GetInfo"));
	HexHub::Users::GetIP							= reinterpret_cast<lpfnGetIP>								(GetF("GetIP"));
	HexHub::Users::GetIPString						= reinterpret_cast<lpfnGetIPString>							(GetF("GetIPString"));
	HexHub::Users::GetISPName						= reinterpret_cast<lpfnGetISPName>							(GetF("GetISPName"));
	HexHub::Users::GetLanguage						= reinterpret_cast<lpfnGetLanguage>							(GetF("GetLanguage"));
	HexHub::Users::GetMail							= reinterpret_cast<lpfnGetMail>								(GetF("GetMail"));
	HexHub::Users::GetMode							= reinterpret_cast<lpfnGetMode>								(GetF("GetMode"));
	HexHub::Users::GetOpStatus						= reinterpret_cast<lpfnGetOpStatus>							(GetF("GetOpStatus"));
	HexHub::Users::GetShareString					= reinterpret_cast<lpfnGetShareString>						(GetF("GetShareString"));
	HexHub::Users::GetTag							= reinterpret_cast<lpfnGetTag>								(GetF("GetTag"));
	HexHub::Users::GetUserData						= reinterpret_cast<lpfnGetUserData>							(GetF("GetUserData"));
	HexHub::Users::IdFromNick						= reinterpret_cast<lpfnIdFromNick>							(GetF("IdFromNick"));
	HexHub::Users::ModeTransform					= reinterpret_cast<lpfnModeTransform>						(GetF("ModeTransform"));
	HexHub::Users::NickFromId						= reinterpret_cast<lpfnNickFromId>							(GetF("NickFromId"));
	HexHub::Users::SetConnection					= reinterpret_cast<lpfnSetConnection>						(GetF("SetConnection"));
	HexHub::Users::SetDescription					= reinterpret_cast<lpfnSetDescription>						(GetF("SetDescription"));
	HexHub::Users::SetInfo							= reinterpret_cast<lpfnSetInfo>								(GetF("SetInfo"));
	HexHub::Users::SetLanguage						= reinterpret_cast<lpfnSetLanguage>							(GetF("SetLanguage"));
	HexHub::Users::SetMail							= reinterpret_cast<lpfnSetMail>								(GetF("SetMail"));
	HexHub::Users::SetMode							= reinterpret_cast<lpfnSetMode>								(GetF("SetMode"));
	HexHub::Users::SetOpStatus						= reinterpret_cast<lpfnSetOpStatus>							(GetF("SetOpStatus"));
	HexHub::Users::SetShareString					= reinterpret_cast<lpfnSetTag>								(GetF("SetTag"));
	HexHub::Users::SetUserData						= reinterpret_cast<lpfnSetUserData>							(GetF("SetUserData"));
	TryPtr(HexHub::Users::AllocUserData);
	TryPtr(HexHub::Users::ClientNickFromId);
	TryPtr(HexHub::Users::FreeUserData);
	TryPtr(HexHub::Users::GetConnection);
	TryPtr(HexHub::Users::GetDescription);
	TryPtr(HexHub::Users::GetFullInfo);
	TryPtr(HexHub::Users::GetInfo);
	TryPtr(HexHub::Users::GetIP);
	TryPtr(HexHub::Users::GetIPString);
	TryPtr(HexHub::Users::GetISPName);
	TryPtr(HexHub::Users::GetLanguage);
	TryPtr(HexHub::Users::GetMail);
	TryPtr(HexHub::Users::GetMode);
	TryPtr(HexHub::Users::GetOpStatus);
	TryPtr(HexHub::Users::GetShareString);
	TryPtr(HexHub::Users::GetTag);
	TryPtr(HexHub::Users::GetUserData);
	TryPtr(HexHub::Users::IdFromNick);
	TryPtr(HexHub::Users::ModeTransform);
	TryPtr(HexHub::Users::NickFromId);
	TryPtr(HexHub::Users::SetConnection);
	TryPtr(HexHub::Users::SetDescription);
	TryPtr(HexHub::Users::SetInfo);
	TryPtr(HexHub::Users::SetLanguage);
	TryPtr(HexHub::Users::SetMail);
	TryPtr(HexHub::Users::SetMode);
	TryPtr(HexHub::Users::SetOpStatus);
	TryPtr(HexHub::Users::SetShareString);
	TryPtr(HexHub::Users::SetUserData);

	//Registration (User-Specific)
	HexHub::Users::Registration::GetAccessLevel		= reinterpret_cast<lpfnGetAccessLevel>						(GetF("GetAccessLevel"));
	HexHub::Users::Registration::GetAccountId		= reinterpret_cast<lpfnGetAccountId>						(GetF("GetAccountId"));
	HexHub::Users::Registration::GetProfileId		= reinterpret_cast<lpfnGetProfileId>						(GetF("GetProfileId"));
	HexHub::Users::Registration::GetRights			= reinterpret_cast<lpfnGetRights>							(GetF("GetRights"));
	HexHub::Users::Registration::SetAccessLevel		= reinterpret_cast<lpfnSetAccessLevel>						(GetF("SetAccessLevel"));
	HexHub::Users::Registration::SetRights			= reinterpret_cast<lpfnSetRights>							(GetF("SetRights"));
	TryPtr(HexHub::Users::Registration::GetAccessLevel);
	TryPtr(HexHub::Users::Registration::GetAccountId);
	TryPtr(HexHub::Users::Registration::GetProfileId);
	TryPtr(HexHub::Users::Registration::GetRights);
	TryPtr(HexHub::Users::Registration::SetAccessLevel);
	TryPtr(HexHub::Users::Registration::SetRights);

	//Traffic
	HexHub::Users::Traffic::DisableOutputToUser		= reinterpret_cast<lpfnDisableOutputToUser>					(GetF("DisableOutPutToUser"));
	HexHub::Users::Traffic::ProcessUserTraffic		= reinterpret_cast<lpfnProcessUserTraffic>					(GetF("ProcessUserTraffic"));
	TryPtr(HexHub::Users::Traffic::DisableOutputToUser);
	TryPtr(HexHub::Users::Traffic::ProcessUserTraffic);

	return true;
}

float HexHub::HelperApi::Math::GetPercentage(float fLowValue, float fHighValue)
{
	float pct;
	pct = (100/fHighValue)*fLowValue;
	return pct;
}
